// -*-C++-*-
//
// File:      ExposureButton.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Mon Jul  9 11:02:42 MET DST 2001

#ifndef ExposureButton_h
#define ExposureButton_h
#include <qpushbutton.h>
#include "OdfInfo.h"
#include "ModeType.h"

namespace OdfBrowser {

class ExposureButton : public QPushButton
{
  Q_OBJECT
public:
  ExposureButton(OdfInfo::ObservationExposure*,
		 QWidget* parent=0, const char* name=0);
  virtual ~ExposureButton();

signals:
  // emitted, whenever at this exposure is (de)selected
  void selected(OdfInfo::ObservationExposure*,bool);

public  slots:
  // show different information in the text of the button
  void toggleText();
  void show(OdfBrowser::ModeType,bool);

protected:
  // only derived classes can use these

private slots:
  // select the type of information in the button text
  void useId(bool on);

private:
  enum State {ID,MODE,FILTER};

  // member functions
  ExposureButton(const ExposureButton&);      // copy constructor (disabled)
  ExposureButton& operator=(const ExposureButton&); // assignment (disabled)

  // member data
  OdfInfo::ObservationExposure* _exposure;
  State    _state;
};

}; // namespace OdfBrowser

#endif
