// -*-C++-*-
//
// File:      ExposureButtonsView.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Mon Jul  9 11:23:36 MET DST 2001

#ifndef ExposureButtonsView_h
#define ExposureButtonsView_h
#include <qscrollview.h> 
#include "OdfInfo.h"
#include "ModeType.h"

namespace OdfBrowser {

class ExposureButtonsView : public QScrollView
{
  Q_OBJECT


// *** interface begin ***
public:
  ExposureButtonsView(const OdfInfo::Odf*,
		      QWidget* parent=0, const char* name=0);
  virtual ~ExposureButtonsView();

signals:
  // ask all buttons in this view to change their text
  void toggleText();

  // emitted, whenever at least one exposure for an instrument is selected
  void activated(Xmm::Instrument,bool);

  // emitted, whenever an exposure is (de)selected
  void selected(OdfInfo::ObservationExposure*,bool);
  
  // emitted, whenever a ModeType is (un)filtered
  void filtered(OdfBrowser::ModeType,bool);

public  slots:
  // TODO: (de)select all
  //void selectAll(bool)

protected:
  // only derived classes can use these

protected slots:

// *** interface end ***


private slots:

private:
  // member functions
  ExposureButtonsView();
  ExposureButtonsView(const ExposureButtonsView&);
  ExposureButtonsView& operator=(const ExposureButtonsView&);

  // add a row of exposures for a particular instrument at vertical position
  void addView(Xmm::Instrument,int);

  // member data
  const OdfInfo::Odf* _odf;
  int _dx,_dy,_by;  // spacing between buttons, button height (pixels)
  int _mx,_my;      // maximum scroll width (pixels)

};

}; // namespace OdfBrowser

#endif
