// -*-C++-*-
//
// File:      ExposurePalette.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Thu Jul  5 11:36:08 MET DST 2001

#include "ExposurePalette.h"
#include "ModeType.h"
using namespace OdfBrowser;

static QPalette engineering;
static QPalette scienceFull;
static QPalette scienceFast;

ExposurePalette* ExposurePalette::_instance=0;
ExposurePalette::ExposurePalette() 
{
    QColorGroup cg;

    // engineering
    cg.setColor( QColorGroup::Foreground, Qt::black );
    cg.setColor( QColorGroup::Button, Qt::red );
    //    cg.setColor( QColorGroup::Button, QColor( 255, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 127, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 255, 63, 159) );
    cg.setColor( QColorGroup::Dark, QColor( 127, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 170, 0, 85) );
    cg.setColor( QColorGroup::Text, Qt::black );
    cg.setColor( QColorGroup::BrightText, Qt::white );
    cg.setColor( QColorGroup::ButtonText, Qt::white );
    cg.setColor( QColorGroup::Base, Qt::white );
    cg.setColor( QColorGroup::Background, QColor( 192, 192, 192) );
    cg.setColor( QColorGroup::Shadow, Qt::black );
    cg.setColor( QColorGroup::Highlight, Qt::black );
    cg.setColor( QColorGroup::HighlightedText, Qt::white );
    engineering.setActive( cg );
    cg.setColor( QColorGroup::Foreground, Qt::black );
    cg.setColor( QColorGroup::Button, Qt::red );
    cg.setColor( QColorGroup::Light, QColor( 255, 127, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 255, 38, 147) );
    cg.setColor( QColorGroup::Dark, QColor( 127, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 170, 0, 85) );
    cg.setColor( QColorGroup::Text, Qt::black );
    cg.setColor( QColorGroup::BrightText, Qt::white );
    cg.setColor( QColorGroup::ButtonText, Qt::white );
    cg.setColor( QColorGroup::Base, Qt::white );
    cg.setColor( QColorGroup::Background, QColor( 192, 192, 192) );
    cg.setColor( QColorGroup::Shadow, Qt::black );
    cg.setColor( QColorGroup::Highlight, Qt::black );
    cg.setColor( QColorGroup::HighlightedText, Qt::white );
    engineering.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, Qt::red );
    cg.setColor( QColorGroup::Light, QColor( 255, 127, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 255, 38, 147) );
    cg.setColor( QColorGroup::Dark, QColor( 127, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 170, 0, 85) );
    cg.setColor( QColorGroup::Text, Qt::black );
    cg.setColor( QColorGroup::BrightText, Qt::white );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, Qt::white );
    cg.setColor( QColorGroup::Background, QColor( 192, 192, 192) );
    cg.setColor( QColorGroup::Shadow, Qt::black );
    cg.setColor( QColorGroup::Highlight, Qt::black );
    cg.setColor( QColorGroup::HighlightedText, Qt::white );
    engineering.setDisabled( cg );
  
    // science fast mode
    cg.setColor( QColorGroup::Foreground, Qt::black );
    cg.setColor( QColorGroup::Button, Qt::darkGreen );
    cg.setColor( QColorGroup::Light, QColor( 0, 127, 0) );
    cg.setColor( QColorGroup::Midlight, QColor( 0, 106, 0) );
    cg.setColor( QColorGroup::Dark, QColor( 0, 42, 0) );
    cg.setColor( QColorGroup::Mid, QColor( 0, 56, 0) );
    cg.setColor( QColorGroup::Text, Qt::black );
    cg.setColor( QColorGroup::BrightText, Qt::white );
    cg.setColor( QColorGroup::ButtonText, Qt::white );
    cg.setColor( QColorGroup::Base, Qt::white );
    cg.setColor( QColorGroup::Background, QColor( 192, 192, 192) );
    cg.setColor( QColorGroup::Shadow, Qt::black );
    cg.setColor( QColorGroup::Highlight, Qt::black );
    cg.setColor( QColorGroup::HighlightedText, Qt::white );
    scienceFast.setActive( cg );
    cg.setColor( QColorGroup::Foreground, Qt::black );
    cg.setColor( QColorGroup::Button, Qt::darkGreen );
    cg.setColor( QColorGroup::Light, QColor( 0, 127, 0) );
    cg.setColor( QColorGroup::Midlight, QColor( 0, 97, 0) );
    cg.setColor( QColorGroup::Dark, QColor( 0, 42, 0) );
    cg.setColor( QColorGroup::Mid, QColor( 0, 56, 0) );
    cg.setColor( QColorGroup::Text, Qt::black );
    cg.setColor( QColorGroup::BrightText, Qt::white );
    cg.setColor( QColorGroup::ButtonText, Qt::white );
    cg.setColor( QColorGroup::Base, Qt::white );
    cg.setColor( QColorGroup::Background, QColor( 192, 192, 192) );
    cg.setColor( QColorGroup::Shadow, Qt::black );
    cg.setColor( QColorGroup::Highlight, Qt::black );
    cg.setColor( QColorGroup::HighlightedText, Qt::white );
    scienceFast.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, Qt::darkGreen );
    cg.setColor( QColorGroup::Light, QColor( 0, 127, 0) );
    cg.setColor( QColorGroup::Midlight, QColor( 0, 97, 0) );
    cg.setColor( QColorGroup::Dark, QColor( 0, 42, 0) );
    cg.setColor( QColorGroup::Mid, QColor( 0, 56, 0) );
    cg.setColor( QColorGroup::Text, Qt::black );
    cg.setColor( QColorGroup::BrightText, Qt::white );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, Qt::white );
    cg.setColor( QColorGroup::Background, QColor( 192, 192, 192) );
    cg.setColor( QColorGroup::Shadow, Qt::black );
    cg.setColor( QColorGroup::Highlight, Qt::black );
    cg.setColor( QColorGroup::HighlightedText, Qt::white );
    scienceFast.setDisabled( cg );


    // science full mode
    cg.setColor( QColorGroup::Foreground, Qt::black );
    cg.setColor( QColorGroup::Button, QColor( 0, 0, 255) );
    cg.setColor( QColorGroup::Light, QColor( 127, 127, 255) );
    cg.setColor( QColorGroup::Midlight, QColor( 63, 63, 255) );
    cg.setColor( QColorGroup::Dark, QColor( 0, 0, 127) );
    cg.setColor( QColorGroup::Mid, QColor( 0, 0, 170) );
    cg.setColor( QColorGroup::Text, Qt::black );
    cg.setColor( QColorGroup::BrightText, Qt::white );
    cg.setColor( QColorGroup::ButtonText, Qt::white );
    cg.setColor( QColorGroup::Base, Qt::white );
    cg.setColor( QColorGroup::Background, QColor( 192, 192, 192) );
    cg.setColor( QColorGroup::Shadow, Qt::black );
    cg.setColor( QColorGroup::Highlight, Qt::black );
    cg.setColor( QColorGroup::HighlightedText, Qt::white );
    scienceFull.setActive( cg );
    cg.setColor( QColorGroup::Foreground, Qt::black );
    cg.setColor( QColorGroup::Button, QColor( 0, 0, 255) );
    cg.setColor( QColorGroup::Light, QColor( 127, 127, 255) );
    cg.setColor( QColorGroup::Midlight, QColor( 38, 38, 255) );
    cg.setColor( QColorGroup::Dark, QColor( 0, 0, 127) );
    cg.setColor( QColorGroup::Mid, QColor( 0, 0, 170) );
    cg.setColor( QColorGroup::Text, Qt::black );
    cg.setColor( QColorGroup::BrightText, Qt::white );
    cg.setColor( QColorGroup::ButtonText, Qt::white );
    cg.setColor( QColorGroup::Base, Qt::white );
    cg.setColor( QColorGroup::Background, QColor( 192, 192, 192) );
    cg.setColor( QColorGroup::Shadow, Qt::black );
    cg.setColor( QColorGroup::Highlight, Qt::black );
    cg.setColor( QColorGroup::HighlightedText, Qt::white );
    scienceFull.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 0, 0, 255) );
    cg.setColor( QColorGroup::Light, QColor( 127, 127, 255) );
    cg.setColor( QColorGroup::Midlight, QColor( 38, 38, 255) );
    cg.setColor( QColorGroup::Dark, QColor( 0, 0, 127) );
    cg.setColor( QColorGroup::Mid, QColor( 0, 0, 170) );
    cg.setColor( QColorGroup::Text, Qt::black );
    cg.setColor( QColorGroup::BrightText, Qt::white );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, Qt::white );
    cg.setColor( QColorGroup::Background, QColor( 192, 192, 192) );
    cg.setColor( QColorGroup::Shadow, Qt::black );
    cg.setColor( QColorGroup::Highlight, Qt::black );
    cg.setColor( QColorGroup::HighlightedText, Qt::white );
    scienceFull.setDisabled( cg );
}

ExposurePalette::~ExposurePalette()
{
}

ExposurePalette* ExposurePalette::instance()
{
  if (_instance==0) {_instance=new ExposurePalette;}
  return _instance;
}

const QPalette& ExposurePalette::palette(Xmm::Mode mode) const
{

  ModeType type=toModeType(mode);

  switch(type) {
  case ScienceFull:
    return scienceFull;
  case ScienceFast:
    return scienceFast;
  case Engineering:
    return engineering;
  default:
    return engineering;
  };
}
