// -*-C++-*-
//
// File:      ExposurePalette.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Thu Jul  5 11:32:01 MET DST 2001

#ifndef ExposurePalette_h
#define ExposurePalette_h

#include <Xmm.h>
#include <qpalette.h>

namespace OdfBrowser {

/**
 * Singleton that generates Color Palette for Exposure buttons
 *
 */
class ExposurePalette 
{ 
public:
  ~ExposurePalette();

  // the single instance of this class
  static ExposurePalette* instance();

  // color scheme for this mode
  const QPalette& palette(Xmm::Mode) const;

protected:
  // need to specify at least one constructor here, or GCC will trip over :-(
  ExposurePalette();                         // default constructor (...)

private:
  // member functions
  ExposurePalette(const ExposurePalette&);      // copy constructor (disabled)
  ExposurePalette& operator=(const ExposurePalette&); // assignment (disabled)

  // member data
  static ExposurePalette* _instance;
};

}; // namespace OdfBrowser

#endif
