// -*-C++-*-
//
// File:      ExposureTimeBar.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Mon Jul  9 14:06:38 MET DST 2001

#include "ExposureTimeBar.h"
#include <qpainter.h> 
using namespace OdfBrowser;

ExposureTimeBar::ExposureTimeBar(const STime& start,const STime& stop,
				 int width,
				 QWidget* parent, const char* name) : 
  QWidget(parent,name), _start(start), _stop(stop), _width(width)
{
  setMinimumWidth(_width);
}

ExposureTimeBar::~ExposureTimeBar()
{
}

void ExposureTimeBar::paintEvent ( QPaintEvent * )
{
  int posY=5;
  int tickLen=5;
  int fontH=10;

  QPainter paint(this);
  paint.setPen( Qt::blue );
  paint.drawLine(0,posY,_width,posY);
  QFont f;
  f.setPixelSize(fontH);
  paint.setFont(f);
  // tickmarks every 1000/2000s:
  double duration=_stop-_start;
  int tickMark=(duration < 40000)?1000:2000;
  for (int tick=0;tick<duration;tick+=tickMark) {
    int posX=int(tick/duration*_width);
    paint.drawLine(posX,posY,posX,posY+tickLen);

    QString s(QString::number(tick/1000));
    paint.drawText(posX+1,posY+tickLen+fontH,s);
  }

}
