// -*-C++-*-
//
// File:      ExposuresView.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Thu Jul 12 15:20:18 MET DST 2001

#ifndef ExposuresView_h
#define ExposuresView_h
#include <qwidget.h>
#include "Xmm.h"
#include "OdfInfo.h"
#include "ModeType.h"

namespace OdfBrowser {

class ExposuresView : public QWidget
{
  Q_OBJECT
public:
  ExposuresView(const OdfInfo::Odf*,
		QWidget* parent=0, const char* name=0);
  virtual ~ExposuresView();

signals:
  // ask all buttons in this view to change their text
  void toggleText();

  // (de)select
  //void selectAll(bool)

  // emitted, whenever at least one exposure for an instrument is selected
  void activated(Xmm::Instrument,bool);

  // emitted, whenever an exposure is (de)selected
  void selected(OdfInfo::ObservationExposure*,bool);

  // emitted, whenever a ModeType is (un)filtered
  void filtered(OdfBrowser::ModeType,bool);
public  slots:

private slots:

protected:
  // only derived classes can use these

private:
  // member functions
  ExposuresView(const ExposuresView&);            // copy constructor (disabled)
  ExposuresView& operator=(const ExposuresView&); // assignment (disabled)

  // member data

};

}; // namespace OdfBrowser

#endif
