// -*-C++-*-
//
// File:      FilterButton.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Tue Jul 17 16:37:48 MET DST 2001

#include "FilterButton.h"
#include <qtoolbar.h>
#include <qtooltip.h>
#include "filter.xpm"
using namespace OdfBrowser;

FilterButton::FilterButton(QToolBar* parent, const char* name) : 
  QToolButton(QPixmap(filter_xpm),QString::null,QString::null,0,0,parent,name),
  _state(false)
{
  // << taken from one of the QToolButton constructors
  if ( parent->mainWindow() ) {
    connect( parent->mainWindow(), SIGNAL(pixmapSizeChanged(bool)),
	     this, SLOT(setUsesBigPixmap(bool)) );
    setUsesBigPixmap( parent->mainWindow()->usesBigPixmaps() );
  } else {
    setUsesBigPixmap( false );
  }
  // >>
  connect(this,SIGNAL(clicked()),this,SLOT(popup()));

  QToolTip::add( this, "Show/hide engineering modes" );
}

FilterButton::~FilterButton()
{
}

void FilterButton::popup()
{
  _state= !_state;
  emit filtered(OdfBrowser::Engineering,_state);
}
