// -*-C++-*-
//
// File:      ModeType.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Tue Jul 17 16:15:32 MET DST 2001

#include "ModeType.h"

OdfBrowser::ModeType OdfBrowser::toModeType(Xmm::Mode mode)
{
  switch(mode) {

  /* Science Full Modes */
  case Xmm::PRIME_FULL_WINDOW:

  // EMOS specific
  case Xmm::PRIME_PARTIAL_RFS:
  case Xmm::PRIME_PARTIAL_W2:
  case Xmm::PRIME_PARTIAL_W3:
  case Xmm::PRIME_PARTIAL_W4:
  case Xmm::PRIME_PARTIAL_W5:
  case Xmm::PRIME_PARTIAL_W6:

  // RGS specific
  case Xmm::SPECTROSCOPY:
  case Xmm::HIGH_EVENT_RATE:
  case Xmm::HIGH_EVENT_RATE_WITH_SES:
  case Xmm::HIGH_EVENT_RATE_WITH_SER:

  // EPN specific
  case Xmm::PRIME_FULL_WINDOW_EXTENDED:
  case Xmm::PRIME_LARGE_WINDOW:
  case Xmm::PRIME_SMALL_WINDOW:

  // OM specific
  case Xmm::IMAGE:

    return OdfBrowser::ScienceFull;


  /* Science Fast Modes */

  // EMOS specific
  case Xmm::FAST_UNCOMPRESSED:
  case Xmm::FAST_COMPRESSED:

  // RGS specific
  case Xmm::HIGH_TIME_RESOLUTION_SINGLE_CCD:
  case Xmm::HIGH_TIME_RESOLUTION_MULTIPLE_CCD:


  // EPN specific
  case Xmm::FAST_TIMING:
  case Xmm::FAST_BURST:

  // OM specific
  case Xmm::FAST:

    return OdfBrowser::ScienceFast;


  /* Engineering Modes */
  case Xmm::EXTRA_HEATING_DEICING:
  case Xmm::EXTRA_HEATING_DECONTAM:
  case Xmm::IN_FLIGHT_TEST:

  // EMOS specific
  case Xmm::OFFSET_VARIANCE:
  case Xmm::CCD_DIAGNOSTIC:
  case Xmm::EXTRA_HEATING_ANNEALING:

  // RGS specific
  case Xmm::DIAGNOSTIC_1X1:
  case Xmm::DIAGNOSTIC_2X2:
  case Xmm::DIAGNOSTIC_3X3:
  case Xmm::DIAGNOSTIC_4X4:
  case Xmm::DIAGNOSTIC_5X5:
  case Xmm::SPECTROSCOPY_TEST:
  case Xmm::DIAGNOSTIC_TEST:

  // EPN specific
  case Xmm::PRIME_FULL_OFFSET:
  case Xmm::PRIME_LARGE_OFFSET:
  case Xmm::OFFSET:
  case Xmm::NOISE:
  case Xmm::DIAGNOSTIC:

  // OM specific
  case Xmm::RAW_DATA_BLUE_DSP12:
  case Xmm::RAW_DATA_BLUE_DSP1:
  case Xmm::RAW_DATA_BLUE_DSP2:
  case Xmm::CENTROIDING_DATA:
  case Xmm::FULL_FRAME:
  case Xmm::CENTROIDING_CONFIRMATION:
  case Xmm::INTENSIFIER_CHARACTERISTICS:
  case Xmm::FLATFIELDING:
    return OdfBrowser::Engineering;

  default:
    return OdfBrowser::Engineering;
  };

  // we should never get here!
  return OdfBrowser::Engineering;

}
