// -*-C++-*-
//
// File:      OdfInfoView.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Thu Jul 12 17:32:58 MET DST 2001

#include "OdfInfoView.h"
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qmessagebox.h>


using namespace OdfBrowser;

class KeyLabel : public QLabel
{
public:
  KeyLabel(const QString& txt,QWidget* parent) : QLabel(txt,parent)
    {
      /*
      QFont f(font());
      f.setWeight (QFont::Bold);
      setFont(f);
      */

      // frame
      setFrameStyle( Box );
      setFixedHeight(.8*height());      
    }
};
class ValLabel : public QLineEdit
{
public:
  ValLabel(const QString& txt,QWidget* parent) : QLineEdit(txt,parent)
    {
      setReadOnly (true);

      /*
      setAlignment(AlignRight);
      setMargin(0);
      setFrameStyle( WinPanel | Sunken );
      */
      setFixedHeight(.8*height());
    }
};

class ValButton : public QPushButton
{
public:
  ValButton(const QString& txt,QWidget* parent) : QPushButton(txt,parent) 
    {
      setFixedHeight(.8*height());
      setFixedWidth(width());
    }
};

OdfInfoView::OdfInfoView(const OdfInfo::Odf* odf,
			 QWidget* parent, const char* name) :
  QWidget(parent,name),_odf(odf)
{


  //                                     rows,cols,border,space
  QGridLayout* grid=new QGridLayout(this,5,4,0,0);
  grid->setColStretch(1,1);
  grid->setColStretch(3,1);

  grid->addWidget(new KeyLabel(" Data Location:",this),0,0);
  grid->addMultiCellWidget(new ValLabel(odf->location().c_str(),this),0,0,1,3);

  grid->addWidget(new KeyLabel(" Start Time:",this),1,0);
  grid->addWidget(new ValLabel(odf->start().toString().c_str(),this),1,1);

  grid->addWidget(new KeyLabel(" End Time:",this),2,0);
  grid->addWidget(new ValLabel(odf->stop().toString().c_str(),this),2,1);

  grid->addWidget(new KeyLabel(" Duration:",this),3,0);
  grid->addWidget(new ValLabel(QString::number(int(odf->stop()-odf->start()))
			       + " seconds",this),3,1);

  grid->addWidget(new KeyLabel(" Proposal:",this),4,0);
  ValButton* proposal=new ValButton(" Details",this);
  grid->addWidget(proposal,4,1,AlignLeft);
  connect(proposal,SIGNAL(clicked()),this,SLOT( proposalDetails()));

  grid->addWidget(new KeyLabel(" Observation Id:",this),1,2);
  grid->addWidget(new ValLabel(odf->observationId().c_str(),this),1,3);
  
  grid->addWidget(new KeyLabel(" Proposal Id:",this),2,2);
  grid->addWidget(new ValLabel(odf->proposalId().c_str(),this),2,3);

  grid->addWidget(new KeyLabel(" Revolution No:",this),3,2);
  grid->addWidget(new ValLabel(QString::number(odf->revolution()),this),3,3);

  grid->addWidget(new KeyLabel(" Slew:",this),4,2);
  grid->addWidget(new ValLabel(odf->isSlew()?"yes":"no",this),4,3);
}

OdfInfoView::~OdfInfoView()
{
}


void OdfInfoView::proposalDetails()
{
   QMessageBox::information( this, "Proposal details",
			     "Sorry, not yet implemented!" );
}
