// -*-C++-*-
//
// File:      ProcButton.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Tue Jul 10 10:14:24 MET DST 2001

#ifndef ProcButton_h
#define ProcButton_h
#include <qtoolbutton.h>
#include "OdfInfo.h"

namespace Info {class Task;} // forward declaration!

namespace OdfBrowser {

class ProcButton : public QToolButton
{
  Q_OBJECT
public:
  virtual ~ProcButton();

  // returns a toolbar button for an instrument
  static ProcButton* instantiate(Xmm::Instrument,QToolBar *);

signals:
  void selected(Info::Task*,bool);

public  slots:
  // adds/removes a selected exposure from current selections
  void selected(OdfInfo::ObservationExposure*,bool);

protected:
  ProcButton(QToolBar * parent,const char * name = 0);

  // methods
  virtual bool canHandle(OdfInfo::ObservationExposure* e)=0;  

  // member data
  Info::Task* _proc;
  OdfInfo::ObservationExposureList _exposures;

private slots:
  void configure();

private:
  // member functions
  ProcButton();
  ProcButton(const ProcButton&);      // copy constructor (disabled)
  ProcButton& operator=(const ProcButton&); // assignment (disabled)

  bool updateParameters();

};


}; // namespace OdfBrowser

#endif
